#include "newCalcFundamental.h"

using namespace std ;

/**
 * @file calcKparameter.cc
 * @brief ΥΥѥ᡼׻
 * @param F ù
 * @author Kento YAMADA
 * @date 2009.4.1
 */
void calcKparameter( const Mat F, double &a1, double &a2, double &a3, double &a4, double &a5 ) {

  double kFk, sqFk, sqFtk ;  //!< ׻ʷ˵Ҥ뤿Υ
  VecC k( 0, 0, 1 ) ;  //!< ٥ȥ

  /* Ƽѥ᡼׻ */
  kFk   = (k,F*k) ;
  sqFk  = sqnorm(F*k) ;
  sqFtk = sqnorm(~F*k) ;


  /* a_{1}, a_{2}, a_{3}, a_{4}, a_{5} ׻ */
  a1 = 0.5 * kFk * kFk * kFk * kFk ;
  a2 = kFk * kFk * (sqFtk + sqFk ) ;
  a3 = 0.5 * (sqFtk - sqFk) * (sqFtk - sqFk)
     + (kFk * (4*(k,F*~F*F*k) - kFk*F.sqnorm())) ;
  a4 = 2.0 * (sqnorm(F*~F*k)+sqnorm(~F*F*k))
     - (sqFtk+sqFk)*F.sqnorm() ;
  a5 = (F*~F).sqnorm() - 0.5 * F.sqnorm() * F.sqnorm() ;

}
